unit schHistoricoMovimientosClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_HISTORICO_MOVIMIENTOS = '{501EFA9F-4F86-42D1-A8FB-9EE6E8B67BE4}';

  { Data table names }
  nme_HISTORICO_MOVIMIENTOS = 'HISTORICO_MOVIMIENTOS';

  { HISTORICO_MOVIMIENTOS fields }
  fld_HISTORICO_MOVIMIENTOSFECHA = 'FECHA';
  fld_HISTORICO_MOVIMIENTOSID_ALMACEN = 'ID_ALMACEN';
  fld_HISTORICO_MOVIMIENTOSID_EMPRESA = 'ID_EMPRESA';
  fld_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN = 'NOMBRE_ALMACEN';
  fld_HISTORICO_MOVIMIENTOSID_ARTICULO = 'ID_ARTICULO';
  fld_HISTORICO_MOVIMIENTOSFAMILIA = 'FAMILIA';
  fld_HISTORICO_MOVIMIENTOSREFERENCIA = 'REFERENCIA';
  fld_HISTORICO_MOVIMIENTOSREFERENCIA_PROV = 'REFERENCIA_PROV';
  fld_HISTORICO_MOVIMIENTOSDESCRIPCION = 'DESCRIPCION';
  fld_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO = 'TIPO_MOVIMIENTO';
  fld_HISTORICO_MOVIMIENTOSCANTIDAD = 'CANTIDAD';
  fld_HISTORICO_MOVIMIENTOSCAUSA = 'CAUSA';

  { HISTORICO_MOVIMIENTOS field indexes }
  idx_HISTORICO_MOVIMIENTOSFECHA = 0;
  idx_HISTORICO_MOVIMIENTOSID_ALMACEN = 1;
  idx_HISTORICO_MOVIMIENTOSID_EMPRESA = 2;
  idx_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN = 3;
  idx_HISTORICO_MOVIMIENTOSID_ARTICULO = 4;
  idx_HISTORICO_MOVIMIENTOSFAMILIA = 5;
  idx_HISTORICO_MOVIMIENTOSREFERENCIA = 6;
  idx_HISTORICO_MOVIMIENTOSREFERENCIA_PROV = 7;
  idx_HISTORICO_MOVIMIENTOSDESCRIPCION = 8;
  idx_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO = 9;
  idx_HISTORICO_MOVIMIENTOSCANTIDAD = 10;
  idx_HISTORICO_MOVIMIENTOSCAUSA = 11;

type
  { IHISTORICO_MOVIMIENTOS }
  IHISTORICO_MOVIMIENTOS = interface(IDAStronglyTypedDataTable)
  ['{E5D2E089-2433-4EC0-B2E2-96A018F64B87}']
    { Property getters and setters }
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetID_ALMACENValue: Integer;
    procedure SetID_ALMACENValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetNOMBRE_ALMACENValue: String;
    procedure SetNOMBRE_ALMACENValue(const aValue: String);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVValue: String;
    procedure SetREFERENCIA_PROVValue(const aValue: String);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetTIPO_MOVIMIENTOValue: String;
    procedure SetTIPO_MOVIMIENTOValue(const aValue: String);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetCAUSAValue: String;
    procedure SetCAUSAValue(const aValue: String);


    { Properties }
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property NOMBRE_ALMACEN: String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROV: String read GetREFERENCIA_PROVValue write SetREFERENCIA_PROVValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property TIPO_MOVIMIENTO: String read GetTIPO_MOVIMIENTOValue write SetTIPO_MOVIMIENTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
  end;

  { THISTORICO_MOVIMIENTOSDataTableRules }
  THISTORICO_MOVIMIENTOSDataTableRules = class(TDADataTableRules, IHISTORICO_MOVIMIENTOS)
  private
  protected
    { Property getters and setters }
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetNOMBRE_ALMACENValue: String; virtual;
    procedure SetNOMBRE_ALMACENValue(const aValue: String); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVValue: String; virtual;
    procedure SetREFERENCIA_PROVValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetTIPO_MOVIMIENTOValue: String; virtual;
    procedure SetTIPO_MOVIMIENTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetCAUSAValue: String; virtual;
    procedure SetCAUSAValue(const aValue: String); virtual;

    { Properties }
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property NOMBRE_ALMACEN: String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROV: String read GetREFERENCIA_PROVValue write SetREFERENCIA_PROVValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property TIPO_MOVIMIENTO: String read GetTIPO_MOVIMIENTOValue write SetTIPO_MOVIMIENTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ THISTORICO_MOVIMIENTOSDataTableRules }
constructor THISTORICO_MOVIMIENTOSDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor THISTORICO_MOVIMIENTOSDataTableRules.Destroy;
begin
  inherited;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSFECHA].AsDateTime;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSFECHA].AsDateTime := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetID_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSID_ALMACEN].AsInteger;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetID_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSID_ALMACEN].AsInteger := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSID_EMPRESA].AsInteger;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSID_EMPRESA].AsInteger := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetNOMBRE_ALMACENValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetNOMBRE_ALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN].AsString := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSID_ARTICULO].AsInteger;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSID_ARTICULO].AsInteger := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSFAMILIA].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSFAMILIA].AsString := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSREFERENCIA].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSREFERENCIA].AsString := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetREFERENCIA_PROVValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSREFERENCIA_PROV].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetREFERENCIA_PROVValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSREFERENCIA_PROV].AsString := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSDESCRIPCION].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSDESCRIPCION].AsString := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetTIPO_MOVIMIENTOValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetTIPO_MOVIMIENTOValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO].AsString := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSCANTIDAD].AsInteger;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSCANTIDAD].AsInteger := aValue;
end;

function THISTORICO_MOVIMIENTOSDataTableRules.GetCAUSAValue: String;
begin
  result := DataTable.Fields[idx_HISTORICO_MOVIMIENTOSCAUSA].AsString;
end;

procedure THISTORICO_MOVIMIENTOSDataTableRules.SetCAUSAValue(const aValue: String);
begin
  DataTable.Fields[idx_HISTORICO_MOVIMIENTOSCAUSA].AsString := aValue;
end;


initialization
  RegisterDataTableRules(RID_HISTORICO_MOVIMIENTOS, THISTORICO_MOVIMIENTOSDataTableRules);

end.
